

// En rekursiv algoritme for utregning av Fibonacci-tallene?

import java.lang.*;

class Fibonazi
{
    public static void main(String [] args)
    {

	boolean rekke = false;

	if ((args.length > 1) && (args[1].equals("j")))
	    rekke = true;

	// System.out.println(rekFib.ekkelFib(Integer.parseInt(args[0])));
//	System.out.println(rekFib.mindreEkkelFib(Integer.parseInt(args[0]), rekke));
	System.out.println(rekFib.formelFib(Integer.parseInt(args[0])));
    }
}

class rekFib
{
    public static long ekkelFib(int sopp)
    {

	// Formel: fib(n) = fib(n-2) + fib(n-1)
	 
	// Denne formelen gir en haug og en sekk av dobbeltarbeide, og jeg
	// vil heller brennes levende enn  bruke den.

	// Kjretid ker med T(N) = T(N-1) + T(N-2) + 2,
	// og hvis hver aritmetiske operasjon tar 10e-9 sekunder, 
	// vil det ta omkring 239 r  regne ut.
	

	if ((sopp == 0) || (sopp == 1))
	    return 1;

	return (ekkelFib(sopp-2) + ekkelFib(sopp-1));

    }

    public static long mindreEkkelFib(int sopp, boolean rekke)
    {
	// Formel: fib(n) = fib(n-2) + fib(n-1)
	
	// regner ut linert og enkelt.
	
	// Kjretid: T(N) = 3*N

     

	if ((sopp == 1) || (sopp == 2))
	    return 1;
	
	long minusto = 1, minusen = 1, nu = 1;
	
	if (rekke) System.out.println("1 : " + minusen + "\n2 : " + nu);

	for(int i = 3; i <= sopp; i++)
	    {
		nu = minusto + minusen;
		if (rekke) System.out.println(i + " : " + nu);
		

		minusto = minusen;
		minusen = nu;

	    }

	return nu;

    }

    public static long formelFib(long sopp)
    {
	// Regner ut fibonacci-tall iflg. formel

	return (long)((Math.sqrt(5)/5) * 
		     (Math.pow(((1 + Math.sqrt(5))/2),sopp) - 
		      Math.pow(((1 - Math.sqrt(5))/2),sopp)));

    }

}
